#if !defined(AFX_ANIMOPENGLRENDERER_H__6FF4CD7B_8013_4F98_BEDF_E3146EAF5815__INCLUDED_)
#define AFX_ANIMOPENGLRENDERER_H__6FF4CD7B_8013_4F98_BEDF_E3146EAF5815__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// AnimOpenGLRenderer.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CAnimOpenGLRenderer window

#include "Node.h"

class CAnimOpenGLRenderer : public CWnd
{
// Construction
public:
	CAnimOpenGLRenderer();

// Attributes
public:

	HGLRC			hglrc;			// OpenGL rendering context

	static HGLRC	first_hglrc;	// OpenGL rc della prima view
	static int		font_list;		// primo nome delle display list dei font

	float			m_fBackgroundColor[3];
	float			m_fAxesColors[3][3];

	CSceneRoot		*m_pSceneRoot;

	float			m_fRotX, m_fRotY, m_fRotZ;
	float			m_fPosX, m_fPosY, m_fPosZ;

	CNode::ERenderMode		m_eRenderMode;

	TimeValue		m_tTime;

	BOOL			m_bShowFrameNumbers;

	float		m_fAmbient[4];
	float		m_fDiffuse[4];

// Operations
public:

	void SetDefaultBackgroundColor()
	{
		m_fBackgroundColor[0] = 128.0f/255.0f;
		m_fBackgroundColor[1] = 128.0f/255.0f;
		m_fBackgroundColor[2] = 128.0f/255.0f;
	}

	CSceneRoot *SetSceneRoot (CSceneRoot *pSceneRoot)
	{
		CSceneRoot *pOldSceneRoot = m_pSceneRoot;
		m_pSceneRoot = pSceneRoot;
		return pOldSceneRoot;
	}

// Helpers
public:

	static int SetupPixelFormat (HDC hDC);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAnimOpenGLRenderer)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CAnimOpenGLRenderer();

	CPoint			m_pntAbsoluteCursorPos;
	CPoint			m_pntOldCursorPos;

	BOOL			m_bRight;

	BOOL			m_bContextMenu;

	// *** m_f_op_1 ***
	float m_f_op_1_xa;
	float m_f_op_1_za;

	// *** m_f_op_2 ***
	float m_f_op_2_a;
	float m_f_op_2_b;
	float m_f_op_2_c;
	float m_f_op_2_d;
	float m_f_op_2_e;
	float m_f_op_2_f;
	float m_f_op_2_g;
	float m_f_op_2_h;
	float m_f_op_2_i;
	int m_i_op_2_x;
	int m_i_op_2_y;

	void DrawMiniAxes (RECT *r);

	void DrawGrid (int iExtension);

	void OnMouseButtonDown (CPoint point, BOOL bRight = FALSE);

	// Generated message map functions
protected:
	//{{AFX_MSG(CAnimOpenGLRenderer)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG
	afx_msg void OnContextMenu(CWnd*, CPoint point);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ANIMOPENGLRENDERER_H__6FF4CD7B_8013_4F98_BEDF_E3146EAF5815__INCLUDED_)
