// IncomingAnimationsBar.cpp : implementation file
//

#include "stdafx.h"
#include "MODELER.h"
#include "IncomingAnimationsBar.h"
#include "DCOMserver.h"
#include "ChildFrm.h"
#include "MainFrm.h"
#include "MODELERDoc.h"
#include "MODELERView.h"
#include "AnimationInfoDialog.h"
#include "ImportPrimitive.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCmdStatic

CCmdStatic::CCmdStatic()
{
}

CCmdStatic::~CCmdStatic()
{
}

BEGIN_MESSAGE_MAP(CCmdStatic, CStatic)
	//{{AFX_MSG_MAP(CCmdStatic)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCmdStatic message handlers

BOOL CCmdStatic::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
	CWnd		*pParent = GetParent();

	ASSERT( pParent != NULL );

	if ( pParent->OnCmdMsg(nID, nCode, pExtra, pHandlerInfo) )
	{
		return TRUE;
	}

	return CStatic::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

/////////////////////////////////////////////////////////////////////////////
// CIncomingAnimationsBar

CIncomingAnimationsBar::CIncomingAnimationsBar() :
	m_bLock(TRUE),
	m_pasdImage(NULL)
{
	InitializeCriticalSection(&m_AnimListAccess);
}

CIncomingAnimationsBar::~CIncomingAnimationsBar()
{
	DeleteCriticalSection(&m_AnimListAccess);
}


BEGIN_MESSAGE_MAP(CIncomingAnimationsBar, CBCGSizingControlBar)
	//{{AFX_MSG_MAP(CIncomingAnimationsBar)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	ON_NOTIFY(NM_CLICK, 2, OnClickAnimList)
	ON_NOTIFY(NM_DBLCLK, 2, OnDblClickAnimList)
	ON_COMMAND(14, OnLockButton)
	ON_COMMAND(10, OnInfoButton)
	ON_COMMAND(11, OnImportSimpleSphereButton)
	ON_COMMAND(12, OnImportSimpleCylinderButton)
	ON_COMMAND(13, OnImportSimpleBoxButton)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CIncomingAnimationsBar message handlers

int CIncomingAnimationsBar::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CBCGSizingControlBar::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here

	CRect rectDummy;
	rectDummy.SetRectEmpty ();

	EnterCriticalSection(&m_AnimListAccess); // ENTERCRITICALSECTION

	if (!m_AnimList.Create (WS_CHILD | WS_VISIBLE | WS_BORDER | LVS_REPORT | LVS_NOSORTHEADER | LVS_SINGLESEL | LVS_SHOWSELALWAYS,
		rectDummy,this,(UINT)2))
	{
		TRACE0("Failed to create CIncomingAnimationsBar::m_AnimList\n");
		return -1;      // fail to create
	}

	if ( !m_wndSimplePlayer.Create(NULL, _T(""), WS_CHILD | WS_VISIBLE | WS_BORDER, rectDummy, this, (UINT)-1) )
	{
		TRACE0("Failed to create CIncomingAnimationsBar::m_wndSimplePlayer\n");
		return -1;
	}

	if ( !m_wndBorder.Create("", WS_CHILD | WS_VISIBLE, rectDummy, this) )
	{
		TRACE0("Failed to create CIncomingAnimationsBar::m_wndBorder\n");
		return -1;
	}

	m_wndBorder.ModifyStyleEx(0, WS_EX_STATICEDGE);

	DWORD dwButtonStyle = WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON;

	if ( m_wndInfo.Create("", dwButtonStyle, rectDummy, &m_wndBorder, (UINT)10) == 0 ||
		m_wndSphere.Create("", dwButtonStyle, rectDummy, &m_wndBorder, (UINT)11) == 0 ||
		m_wndCylinder.Create("", dwButtonStyle, rectDummy, &m_wndBorder, (UINT)12) == 0 ||
		m_wndBox.Create("", dwButtonStyle, rectDummy, &m_wndBorder, (UINT)13) == 0 ||
		m_wndLock.Create("", dwButtonStyle, rectDummy, &m_wndBorder, (UINT)14) == 0 )
	{
		TRACE0("Failed to create CIncomingAnimationsBar buttons\n");
		return -1;
	}

	m_wndInfo.SetImage(theApp.LoadIcon(IDI_INFO));
	m_wndSphere.SetImage(theApp.LoadIcon(IDI_SPHERE));
	m_wndCylinder.SetImage(theApp.LoadIcon(IDI_CYLINDER));
	m_wndBox.SetImage(theApp.LoadIcon(IDI_BOX));
	m_wndLock.SetImage(theApp.LoadIcon(IDI_LOCK));

	m_wndInfo.m_nFlatStyle = CBCGButton::BUTTONSTYLE_FLAT;
	m_wndSphere.m_nFlatStyle = CBCGButton::BUTTONSTYLE_FLAT;
	m_wndCylinder.m_nFlatStyle = CBCGButton::BUTTONSTYLE_FLAT;
	m_wndBox.m_nFlatStyle = CBCGButton::BUTTONSTYLE_FLAT;
	m_wndLock.m_nFlatStyle = CBCGButton::BUTTONSTYLE_FLAT;

	m_wndInfo.SetTooltip("Information");
	m_wndSphere.SetTooltip("Import a simple sphere");
	m_wndCylinder.SetTooltip("Import a simple cylinder");
	m_wndBox.SetTooltip("Import a simple box");
	m_wndLock.SetTooltip("Unlock animation");

	m_wndInfo.GetToolTipCtrl().SetWindowPos(&wndTopMost, -1, -1, -1, -1, SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE);
	m_wndSphere.GetToolTipCtrl().SetWindowPos(&wndTopMost, -1, -1, -1, -1, SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE);
	m_wndCylinder.GetToolTipCtrl().SetWindowPos(&wndTopMost, -1, -1, -1, -1, SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE);
	m_wndBox.GetToolTipCtrl().SetWindowPos(&wndTopMost, -1, -1, -1, -1, SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE);
	m_wndLock.GetToolTipCtrl().SetWindowPos(&wndTopMost, -1, -1, -1, -1, SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOSIZE);

	m_AnimList.SetFont(&globalData.fontRegular,FALSE);
	m_AnimList.SendMessage (LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);

	m_AnimList.InsertColumn(0,"Name");
	m_AnimList.InsertColumn(1,"Size");
	m_AnimList.InsertColumn(2,"From");

	LeaveCriticalSection(&m_AnimListAccess); // LEAVECRITICALSECTION

	return 0;
}

void CIncomingAnimationsBar::OnSize(UINT nType, int cx, int cy) 
{
	CBCGSizingControlBar::OnSize(nType, cx, cy);

	int			iPlayerHeight = cx < cy/2 ? cx : cy/2;
	const int	iBorderHeight = 23;
	const int	iButtonWidth = 21;

	m_wndBorder.SetWindowPos (NULL, 0, 0, cx, iBorderHeight, SWP_NOACTIVATE | SWP_NOZORDER);

	m_wndLock.SetWindowPos (NULL, 0, 0, iButtonWidth, 21, SWP_NOACTIVATE | SWP_NOZORDER);
	m_wndInfo.SetWindowPos (NULL, iButtonWidth, 0, iButtonWidth, 21, SWP_NOACTIVATE | SWP_NOZORDER);

	int			iButtonSpace = iButtonWidth * 3 + 2;

	m_wndBox.SetWindowPos (NULL, cx - iButtonSpace, 0, iButtonWidth, 21, SWP_NOACTIVATE | SWP_NOZORDER);
	iButtonSpace -= iButtonWidth;

	m_wndCylinder.SetWindowPos (NULL, cx - iButtonSpace, 0, iButtonWidth, 21, SWP_NOACTIVATE | SWP_NOZORDER);
	iButtonSpace -= iButtonWidth;

	m_wndSphere.SetWindowPos (NULL, cx - iButtonSpace, 0, iButtonWidth, 21, SWP_NOACTIVATE | SWP_NOZORDER);
	iButtonSpace -= iButtonWidth;

	EnterCriticalSection(&m_AnimListAccess); // ENTERCRITICALSECTION
	
	// TODO: Add your message handler code here

	int			iAnimListHeight;

	m_AnimList.SetWindowPos (NULL, 0, iBorderHeight+2, cx, (iAnimListHeight = cy-iPlayerHeight-2) - iBorderHeight - 2,
		SWP_NOACTIVATE | SWP_NOZORDER);

	int			width=cx/4;
	m_AnimList.SetColumnWidth(0,width*2);
	m_AnimList.SetColumnWidth(1,width);
	m_AnimList.SetColumnWidth(2,cx-width*3);

	LeaveCriticalSection(&m_AnimListAccess); // LEAVECRITICALSECTION

	m_wndSimplePlayer.SetWindowPos(NULL, 0, iAnimListHeight+2, cx, iPlayerHeight, SWP_NOACTIVATE | SWP_NOZORDER);

	m_wndInfo.RedrawWindow();
	m_wndSphere.RedrawWindow();
	m_wndCylinder.RedrawWindow();
	m_wndBox.RedrawWindow();
	m_wndLock.RedrawWindow();
}

void CIncomingAnimationsBar::OnDestroy()
{
	FreeAnimListMemory();

	CBCGSizingControlBar::OnDestroy();
}

void CIncomingAnimationsBar::OnClickAnimList(NMHDR* /*pNMHDR*/, LRESULT* /*pResult*/)
{
	EnterCriticalSection(&m_AnimListAccess); // ENTERCRITICALSECTION

	POSITION pos = m_AnimList.GetFirstSelectedItemPosition();

	if ( pos != NULL )
	{

		int nItem = m_AnimList.GetNextSelectedItem(pos);

		LVITEM		item;
		item.mask = LVIF_PARAM;
		item.iItem = nItem;
		item.iSubItem = 0;
		m_AnimList.SendMessage(LVM_GETITEM, 0, (LPARAM) &item);

		CSceneRoot	*pSR = (CSceneRoot*) item.lParam;

		m_wndSimplePlayer.SetSceneRoot(pSR);

	}
	else
	{
		m_wndSimplePlayer.SetSceneRoot(NULL);
	}

	LeaveCriticalSection(&m_AnimListAccess); // LEAVECRITICALSECTION
}

BOOL CIncomingAnimationsBar::PreTranslateMessage(MSG* pMsg)
{
	if ( pMsg->hwnd == m_AnimList.m_hWnd &&
		pMsg->message == WM_KEYDOWN )
	{
		::TranslateMessage(pMsg);
		::DispatchMessage(pMsg);

		// *** valuta se deve cancellare l'animazione ***

		if ( pMsg->wParam == VK_DELETE )
		{
			EnterCriticalSection(&m_AnimListAccess); // ENTERCRITICALSECTION

			POSITION pos = m_AnimList.GetFirstSelectedItemPosition();

			if ( pos != NULL )
			{

				int nItem = m_AnimList.GetNextSelectedItem(pos);

				LVITEM		item;
				item.mask = LVIF_PARAM;
				item.iItem = nItem;
				item.iSubItem = 0;
				m_AnimList.SendMessage(LVM_GETITEM, 0, (LPARAM) &item);

				CSceneRoot	*pSR = (CSceneRoot*) item.lParam;

				delete pSR;

				m_AnimList.DeleteItem(nItem);

				if ( m_AnimList.GetItemCount() != 0 )
				{
					if ( nItem == m_AnimList.GetItemCount() )
					{
						nItem--;
					}

					m_AnimList.SetItemState(nItem, LVIS_SELECTED|LVIS_FOCUSED,LVIS_SELECTED|LVIS_FOCUSED);
				}

			}

			LeaveCriticalSection(&m_AnimListAccess); // LEAVECRITICALSECTION
		}

		// *** simula un click del mouse ***

		if ( pMsg->wParam == VK_RETURN )
		{
			OnDblClickAnimList(NULL, NULL);
		}
		else
		{
			OnClickAnimList(NULL, NULL);
		}

		return TRUE;
	}

	return CBCGSizingControlBar::PreTranslateMessage(pMsg);
}

void CIncomingAnimationsBar::OnDblClickAnimList(NMHDR* /*pNMHDR*/, LRESULT* /*pResult*/)
{
	EnterCriticalSection(&m_AnimListAccess); // ENTERCRITICALSECTION

	POSITION pos = m_AnimList.GetFirstSelectedItemPosition();

	if ( pos != NULL || m_pasdImage != NULL )
	{
		// *** ottiene MDI child window e documento corrente ***

		CMainFrame		*pMainFrame = (CMainFrame*)AfxGetApp()->m_pMainWnd;

		ASSERT( pMainFrame != NULL );

		BOOL			bMaximized;

		CChildFrame		*pChildFrame = (CChildFrame*)pMainFrame->MDIGetActive(&bMaximized);

		if ( pChildFrame == NULL )
		{
			((CMODELERApp*)AfxGetApp())->NewDocumentFile();

			pChildFrame = (CChildFrame*)pMainFrame->MDIGetActive(&bMaximized);
		}

		if ( pChildFrame != NULL )
		{
			CMODELERView	*pView = (CMODELERView*)pChildFrame->GetActiveView();

			ASSERT( pView != NULL );

			CSceneRoot	*pSR;

			if ( m_pasdImage == NULL )
			{

				int nItem = m_AnimList.GetNextSelectedItem(pos);

				LVITEM		item;
				item.mask = LVIF_PARAM;
				item.iItem = nItem;
				item.iSubItem = 0;
				m_AnimList.SendMessage(LVM_GETITEM, 0, (LPARAM) &item);

				pSR = (CSceneRoot*) item.lParam;

				if ( m_bLock == FALSE )
				{

					// *** cancella l'animazione dalla lista per trasferirla nel documento ***

					m_AnimList.DeleteItem(nItem);

					if ( m_AnimList.GetItemCount() != 0 )
					{
						if ( nItem == m_AnimList.GetItemCount() )
						{
							nItem--;
						}

						m_AnimList.SetItemState(nItem, LVIS_SELECTED|LVIS_FOCUSED,LVIS_SELECTED|LVIS_FOCUSED);
					}

					OnClickAnimList(NULL, NULL);

				}
				else
				{

					// *** duplica l'animazione selezionata ***

					anim_stream_desc_t		*pAnim = (anim_stream_desc_t*)malloc(pSR->m_pASD->StreamSize);

					if ( pAnim == NULL )
					{
						AfxMessageBox("Out Of Memory!");
						pSR = NULL;
					}
					else
					{
						memcpy(pAnim, pSR->m_pASD, pSR->m_pASD->StreamSize);

						pSR = new CSceneRoot(pAnim);

						if ( pSR == NULL || pSR->m_bCorrupt )
						{
							AfxMessageBox("Unable to clone animation!");
							if ( pSR ) { delete pSR; pSR = NULL; }
						}
					}

				}

			}
			else
			{
				pSR = new CSceneRoot(m_pasdImage);

				ASSERT( pSR != NULL && pSR->m_bCorrupt == FALSE );
			}

			// *** aggiunge l'animazione al documento ***

			if ( pSR )
			{

				CMODELERDoc		*pDocument = pView->GetDocument();

				ASSERT( pDocument != NULL );

				pDocument->m_vAnimations.push_back(pSR);

				pDocument->SetModifiedFlag();

				pView->SetShownAnimationNumber( pDocument->m_vAnimations.size() - 1 );

				// *** valuta se ingrandire il child frame ***

				if ( pChildFrame->IsIconic() )
				{
					pChildFrame->MDIRestore();
				}

				// *** valuta se ci sono altre view per questo documento non aggiornate ***

				POSITION viewpos = pDocument->GetFirstViewPosition();
				while (viewpos != NULL)
				{
					CMODELERView* pModelerView = (CMODELERView*)pDocument->GetNextView(viewpos);

					if ( pModelerView->m_iShownAnimation == -1 )
					{
						pModelerView->SetShownAnimationNumber( pDocument->m_vAnimations.size() - 1 );
					}
				}

			}

		}

	}

	LeaveCriticalSection(&m_AnimListAccess); // LEAVECRITICALSECTION
}

void CIncomingAnimationsBar::OnLockButton()
{
	if ( m_bLock )
	{
		m_bLock = FALSE;
		m_wndLock.SetImage(theApp.LoadIcon(IDI_UNLOCK));
		m_wndLock.SetTooltip("Lock animation");
	}
	else
	{
		m_bLock = TRUE;
		m_wndLock.SetImage(theApp.LoadIcon(IDI_LOCK));
		m_wndLock.SetTooltip("Unlock animation");
	}
}

void CIncomingAnimationsBar::OnInfoButton()
{
	EnterCriticalSection(&m_AnimListAccess); // ENTERCRITICALSECTION

	POSITION pos = m_AnimList.GetFirstSelectedItemPosition();

	if ( pos != NULL )
	{

		int nItem = m_AnimList.GetNextSelectedItem(pos);

		LVITEM		item;
		item.mask = LVIF_PARAM;
		item.iItem = nItem;
		item.iSubItem = 0;
		m_AnimList.SendMessage(LVM_GETITEM, 0, (LPARAM) &item);

		CSceneRoot	*pSR = (CSceneRoot*) item.lParam;

		CAnimationInfoDialog		wndDialog(pSR);

		wndDialog.DoModal();

	}
	else
	{
		AfxMessageBox("You have to select an animation to see its info.\n\nUse the MapGen Server Control Plugin for\n3D Studio MAX R3.1 to export animations\ndirectly in the MapGen Modeler application.");
	}

	LeaveCriticalSection(&m_AnimListAccess); // LEAVECRITICALSECTION
}

void CIncomingAnimationsBar::OnImportSimpleSphereButton()
{
	CImportPrimitive		wndDialog("Import a Simple Sphere");

	if ( wndDialog.m_bFatalError == FALSE )
	{
		wndDialog.DoModal();

		if ( strlen(wndDialog.m_szGuidPlusAttributes) )
		{

			anim_stream_desc_t		*pasdImage = (anim_stream_desc_t*)CMODELERApp::LoadFileFromResources("#175", "GeomImage", NULL);

			ASSERT( pasdImage != NULL );

			for ( int i=0; i<pasdImage->StreamSize; i++ )
				if ( !memcmp(&((BYTE*)pasdImage)[i], "(00000000-0000-0000-0000-000000000000) 00000000", 47) )
				{
					memcpy(&((BYTE*)pasdImage)[i], wndDialog.m_szGuidPlusAttributes, 47);
					break;
				}

			m_pasdImage = pasdImage;
			OnDblClickAnimList(NULL, NULL);
			m_pasdImage = NULL;

		}
	}
}

void CIncomingAnimationsBar::OnImportSimpleCylinderButton()
{
	CImportPrimitive		wndDialog("Import a Simple Cylinder");

	if ( wndDialog.m_bFatalError == FALSE )
	{
		wndDialog.DoModal();

		if ( strlen(wndDialog.m_szGuidPlusAttributes) )
		{

			anim_stream_desc_t		*pasdImage = (anim_stream_desc_t*)CMODELERApp::LoadFileFromResources("#176", "GeomImage", NULL);

			ASSERT( pasdImage != NULL );

			for ( int i=0; i<pasdImage->StreamSize; i++ )
				if ( !memcmp(&((BYTE*)pasdImage)[i], "(00000000-0000-0000-0000-000000000000) 00000000", 47) )
				{
					memcpy(&((BYTE*)pasdImage)[i], wndDialog.m_szGuidPlusAttributes, 47);
					break;
				}

			m_pasdImage = pasdImage;
			OnDblClickAnimList(NULL, NULL);
			m_pasdImage = NULL;

		}
	}
}

void CIncomingAnimationsBar::OnImportSimpleBoxButton()
{
	CImportPrimitive		wndDialog("Import a Simple Box");

	if ( wndDialog.m_bFatalError == FALSE )
	{
		wndDialog.DoModal();

		if ( strlen(wndDialog.m_szGuidPlusAttributes) )
		{

			anim_stream_desc_t		*pasdImage = (anim_stream_desc_t*)CMODELERApp::LoadFileFromResources("#177", "GeomImage", NULL);

			ASSERT( pasdImage != NULL );

			for ( int i=0; i<pasdImage->StreamSize; i++ )
				if ( !memcmp(&((BYTE*)pasdImage)[i], "(00000000-0000-0000-0000-000000000000) 00000000", 47) )
				{
					memcpy(&((BYTE*)pasdImage)[i], wndDialog.m_szGuidPlusAttributes, 47);
					break;
				}

			m_pasdImage = pasdImage;
			OnDblClickAnimList(NULL, NULL);
			m_pasdImage = NULL;

		}
	}
}