// MODELERView.cpp : implementation of the CMODELERView class
//

#include "stdafx.h"
#include "MODELER.h"

#include "MODELERDoc.h"
#include "MODELERView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMODELERView

IMPLEMENT_DYNCREATE(CMODELERView, CView)

BEGIN_MESSAGE_MAP(CMODELERView, CView)
	//{{AFX_MSG_MAP(CMODELERView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	ON_WM_CONTEXTMENU()
	ON_WM_SIZE()
	ON_WM_CREATE()
	ON_WM_ERASEBKGND()
	ON_COMMAND(ID_GOTO_START, OnGotoStart)
	ON_UPDATE_COMMAND_UI(ID_GOTO_START, OnUpdateGotoStart)
	ON_COMMAND(ID_PREVIOUS_FRAME, OnPreviousFrame)
	ON_UPDATE_COMMAND_UI(ID_PREVIOUS_FRAME, OnUpdatePreviousFrame)
	ON_COMMAND(ID_PLAYPAUSE, OnPlaypause)
	ON_UPDATE_COMMAND_UI(ID_PLAYPAUSE, OnUpdatePlaypause)
	ON_COMMAND(ID_STOP, OnStop)
	ON_UPDATE_COMMAND_UI(ID_STOP, OnUpdateStop)
	ON_COMMAND(ID_NEXT_FRAME, OnNextFrame)
	ON_UPDATE_COMMAND_UI(ID_NEXT_FRAME, OnUpdateNextFrame)
	ON_COMMAND(ID_GOTO_END, OnGotoEnd)
	ON_UPDATE_COMMAND_UI(ID_GOTO_END, OnUpdateGotoEnd)
	ON_WM_DESTROY()
	ON_WM_TIMER()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMODELERView construction/destruction

CMODELERView::CMODELERView() :
	m_iShownAnimation(-1),
	m_bIsPlaying(FALSE),
	m_bStopButtonEnabled(FALSE),
	m_nTimerElapse(3)
{
	m_wndRenderer.m_bShowFrameNumbers = FALSE;
}

CMODELERView::~CMODELERView()
{
}

BOOL CMODELERView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMODELERView drawing

void CMODELERView::OnDraw(CDC* pDC)
{
	CMODELERDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CMODELERView diagnostics

#ifdef _DEBUG
void CMODELERView::AssertValid() const
{
	CView::AssertValid();
}

void CMODELERView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMODELERDoc* CMODELERView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMODELERDoc)));
	return (CMODELERDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMODELERView message handlers

void CMODELERView::OnContextMenu(CWnd*, CPoint point)
{
	theApp.ShowPopupMenu (IDR_CONTEXT_MENU, point, this);
}

void CMODELERView::OnSize(UINT nType, int cx, int cy)
{
	CView::OnSize(nType, cx, cy);

	// *** imposta la posizione del renderer e del time slider ***

	m_wndRenderer.SetWindowPos(NULL, 0, 0, cx, cy - m_wndTimeSlider.m_uiHeight, SWP_NOACTIVATE | SWP_NOZORDER);

	m_wndTimeSlider.SetWindowPos(NULL, 0, cy - m_wndTimeSlider.m_uiHeight, cx, m_wndTimeSlider.m_uiHeight, SWP_NOACTIVATE | SWP_NOZORDER);
}

int CMODELERView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;

	// *** crea il renderer ed il time slider ***

	CRect rectDummy (0, 0, 0, 0);

	if ( m_wndRenderer.Create(NULL, _T(""), WS_CHILD | WS_VISIBLE, rectDummy, this, (UINT)-1) == 0 ||
		m_wndTimeSlider.Create(NULL, _T(""), WS_CHILD | WS_VISIBLE, rectDummy, this, (UINT)-1) == 0 )
	{
		TRACE0("Failed to create children in CMODELERView::OnCreate!");
		return -1;
	}

	m_wndTimeSlider.m_pMODELERView = this;

	m_wndTimeSlider.m_pAnimOpenGLRenderer = &m_wndRenderer;

	return 0;
}

BOOL CMODELERView::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
}

void CMODELERView::OnGotoStart() 
{
	if ( m_bIsPlaying )
	{
		OnPlaypause();
	}

	m_wndRenderer.m_tTime = m_wndRenderer.m_pSceneRoot->m_pGI->first_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame;
	m_wndRenderer.RedrawWindow();

	m_bStopButtonEnabled = TRUE;

	CRect		rectClient;
	m_wndTimeSlider.GetClientRect(&rectClient);
	m_wndTimeSlider.RecalcLayout(rectClient.Width(), rectClient.Height());
}

void CMODELERView::OnUpdateGotoStart(CCmdUI* pCmdUI) 
{
	if ( m_wndRenderer.m_pSceneRoot == NULL )
	{
		pCmdUI->Enable(FALSE);
	}
	else
	{
		pCmdUI->Enable(m_wndRenderer.m_tTime == m_wndRenderer.m_pSceneRoot->m_pGI->first_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame ? FALSE : TRUE);
	}
}

void CMODELERView::OnPreviousFrame() 
{
	if ( m_bIsPlaying )
	{
		OnPlaypause();
	}

	m_wndRenderer.m_tTime -= m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame;

	if ( m_wndRenderer.m_tTime < m_wndRenderer.m_pSceneRoot->m_pGI->first_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame )
	{
		m_wndRenderer.m_tTime = m_wndRenderer.m_pSceneRoot->m_pGI->last_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame;
	}

	m_wndRenderer.RedrawWindow();

	m_bStopButtonEnabled = TRUE;

	CRect		rectClient;
	m_wndTimeSlider.GetClientRect(&rectClient);
	m_wndTimeSlider.RecalcLayout(rectClient.Width(), rectClient.Height());
}

void CMODELERView::OnUpdatePreviousFrame(CCmdUI* pCmdUI) 
{
	if ( m_wndRenderer.m_pSceneRoot == NULL )
	{
		pCmdUI->Enable(FALSE);
	}
	else
	{
		pCmdUI->Enable(m_wndRenderer.m_tTime == m_wndRenderer.m_pSceneRoot->m_pGI->first_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame ? FALSE : TRUE);
	}
}

void CMODELERView::OnPlaypause() 
{
	// imposta m_bIsPlaying

	if ( m_bIsPlaying )
	{
		m_bIsPlaying = FALSE;

		KillTimer(69);
	}
	else
	{
		m_bIsPlaying = TRUE;

		m_bStopButtonEnabled = TRUE;

		// ricalcola m_nTimerElapse (se  stato modificato il frame speed, aggiorna)
		m_nTimerElapse = CalculateTimerElapse(m_wndRenderer.m_pSceneRoot);

		SetTimer(69, m_nTimerElapse, NULL);
	}
}

void CMODELERView::OnUpdatePlaypause(CCmdUI* pCmdUI) 
{
	if ( m_wndRenderer.m_pSceneRoot == NULL )
	{
		pCmdUI->Enable(FALSE);
	}
	else
	{
		pCmdUI->Enable(HasTimeRange(m_wndRenderer.m_pSceneRoot));
	}

	if ( m_bIsPlaying )
	{
		pCmdUI->SetCheck();
	}
	else
	{
		pCmdUI->SetCheck(0);
	}

	// *** controlla che l'icona visualizzata sia quella giusta ***

	CBCGToolbarButton	*pToolbarButton = GetToolbarButtonPtr(ID_PLAYPAUSE);

	ASSERT( pToolbarButton != NULL );

	if ( m_bIsPlaying )
	{
		if ( pToolbarButton->GetImage() != 13 )
		{
			pToolbarButton->SetImage(13);
		}
	}
	else
	{
		if ( pToolbarButton->GetImage() != 12 )
		{
			pToolbarButton->SetImage(12);
		}
	}
}

void CMODELERView::OnStop() 
{
	m_bStopButtonEnabled = FALSE;

	if ( m_bIsPlaying )
	{
		OnPlaypause();
	}

	m_wndRenderer.m_tTime = m_wndRenderer.m_pSceneRoot->m_pGI->first_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame;
	m_wndRenderer.RedrawWindow();

	CRect		rectClient;
	m_wndTimeSlider.GetClientRect(&rectClient);
	m_wndTimeSlider.RecalcLayout(rectClient.Width(), rectClient.Height());
}

void CMODELERView::OnUpdateStop(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bStopButtonEnabled);
}

void CMODELERView::OnNextFrame() 
{
	if ( m_bIsPlaying )
	{
		OnPlaypause();
	}

	m_wndRenderer.m_tTime += m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame;

	if ( m_wndRenderer.m_tTime > m_wndRenderer.m_pSceneRoot->m_pGI->last_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame )
	{
		m_wndRenderer.m_tTime = m_wndRenderer.m_pSceneRoot->m_pGI->first_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame;
	}

	m_wndRenderer.RedrawWindow();

	m_bStopButtonEnabled = TRUE;

	CRect		rectClient;
	m_wndTimeSlider.GetClientRect(&rectClient);
	m_wndTimeSlider.RecalcLayout(rectClient.Width(), rectClient.Height());
}

void CMODELERView::OnUpdateNextFrame(CCmdUI* pCmdUI) 
{
	if ( m_wndRenderer.m_pSceneRoot == NULL )
	{
		pCmdUI->Enable(FALSE);
	}
	else
	{
		pCmdUI->Enable(m_wndRenderer.m_tTime == m_wndRenderer.m_pSceneRoot->m_pGI->last_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame ? FALSE : TRUE);
	}
}

void CMODELERView::OnGotoEnd() 
{
	if ( m_bIsPlaying )
	{
		OnPlaypause();
	}

	m_wndRenderer.m_tTime = m_wndRenderer.m_pSceneRoot->m_pGI->last_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame;
	m_wndRenderer.RedrawWindow();

	m_bStopButtonEnabled = TRUE;

	CRect		rectClient;
	m_wndTimeSlider.GetClientRect(&rectClient);
	m_wndTimeSlider.RecalcLayout(rectClient.Width(), rectClient.Height());
}

void CMODELERView::OnUpdateGotoEnd(CCmdUI* pCmdUI) 
{
	if ( m_wndRenderer.m_pSceneRoot == NULL )
	{
		pCmdUI->Enable(FALSE);
	}
	else
	{
		pCmdUI->Enable(m_wndRenderer.m_tTime == m_wndRenderer.m_pSceneRoot->m_pGI->last_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame ? FALSE : TRUE);
	}
}

CBCGToolbarButton *CMODELERView::GetToolbarButtonPtr (UINT uiCmd)
{
	CBCGToolbarButton		*pToolbarButton = NULL;

	CObList					listButtons;

	if (CBCGToolBar::GetCommandButtons (uiCmd, listButtons) > 0)
	{
		POSITION posToolbarButton = listButtons.GetHeadPosition ();

		pToolbarButton = DYNAMIC_DOWNCAST(CBCGToolbarButton, listButtons.GetNext (posToolbarButton));
	}

	return pToolbarButton;
}

void CMODELERView::OnDestroy()
{
	CBCGToolbarButton	*pToolbarButton = GetToolbarButtonPtr(ID_PLAYPAUSE);

	ASSERT( pToolbarButton != NULL );

	pToolbarButton->m_nStyle &= ~TBBS_CHECKED;
	pToolbarButton->SetImage(12);

	CView::OnDestroy();
}

void CMODELERView::OnTimer(UINT nIDEvent)
{
	if ( nIDEvent == 69 )
	{
		m_wndRenderer.m_tTime += m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame;

		if ( m_wndRenderer.m_tTime > m_wndRenderer.m_pSceneRoot->m_pGI->last_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame )
		{
			m_wndRenderer.m_tTime = m_wndRenderer.m_pSceneRoot->m_pGI->first_frame * m_wndRenderer.m_pSceneRoot->m_pGI->ticks_per_frame;
		}

		m_wndRenderer.RedrawWindow();

		CRect		rectClient;
		m_wndTimeSlider.GetClientRect(&rectClient);
		m_wndTimeSlider.RecalcLayout(rectClient.Width(), rectClient.Height());
	}

	CView::OnTimer(nIDEvent);
}

void CMODELERView::SetShownAnimationNumber (int iShownAnimation)
{
	m_iShownAnimation = iShownAnimation;

	CSceneRoot		*pSceneRoot = NULL;

	if ( m_iShownAnimation != -1 )
	{
		CMODELERDoc* pDoc = GetDocument();
		ASSERT_VALID(pDoc);

		pSceneRoot = pDoc->m_vAnimations[m_iShownAnimation];
	}

	CSceneRoot		*pOldSceneRoot = m_wndRenderer.SetSceneRoot(pSceneRoot);

	if ( pSceneRoot != pOldSceneRoot && m_bIsPlaying )
	{
		OnPlaypause();
	}

	if ( pSceneRoot == NULL )
	{
		m_wndRenderer.SetDefaultBackgroundColor();

		m_wndRenderer.m_tTime = 0;

		m_bStopButtonEnabled = FALSE;
	}
	else if ( pSceneRoot != pOldSceneRoot )
	{
		m_wndRenderer.m_fBackgroundColor[0] = 175.0f/255.0f;
		m_wndRenderer.m_fBackgroundColor[1] = 175.0f/255.0f;
		m_wndRenderer.m_fBackgroundColor[2] = 175.0f/255.0f;

		m_nTimerElapse = CalculateTimerElapse(pSceneRoot);

		m_wndRenderer.m_tTime = pSceneRoot->m_pGI->first_frame * pSceneRoot->m_pGI->ticks_per_frame;

		m_bStopButtonEnabled = FALSE;
	}

	m_wndRenderer.RedrawWindow();

	CRect		rectClient;
	m_wndTimeSlider.GetClientRect(&rectClient);
	m_wndTimeSlider.RecalcLayout(rectClient.Width(), rectClient.Height());
}